diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/obss-pd-algorithm.h ns-3.43/src/wifi/model/he/obss-pd-algorithm.h
--- ns-3.42/src/wifi/model/he/obss-pd-algorithm.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/obss-pd-algorithm.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -24,6 +13,7 @@
 
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
+#include "ns3/wifi-units.h"
 
 namespace ns3
 {
@@ -88,13 +78,13 @@
                                         double txPowerMaxDbmMimo);
 
     /**
-     * \param level the current OBSS PD level in dBm
+     * \param level the current OBSS PD level
      */
-    void SetObssPdLevel(double level);
+    void SetObssPdLevel(dBm_u level);
     /**
-     * \return the current OBSS PD level in dBm.
+     * \return the current OBSS PD level
      */
-    double GetObssPdLevel() const;
+    dBm_u GetObssPdLevel() const;
 
   protected:
     void DoDispose() override;
@@ -102,11 +92,11 @@
     Ptr<WifiNetDevice> m_device; ///< Pointer to the WifiNetDevice
 
   private:
-    double m_obssPdLevel;    ///< Current OBSS PD level (dBm)
-    double m_obssPdLevelMin; ///< Minimum OBSS PD level (dBm)
-    double m_obssPdLevelMax; ///< Maximum OBSS PD level (dBm)
-    double m_txPowerRefSiso; ///< SISO reference TX power level (dBm)
-    double m_txPowerRefMimo; ///< MIMO reference TX power level (dBm)
+    dBm_u m_obssPdLevel;    ///< Current OBSS PD level
+    dBm_u m_obssPdLevelMin; ///< Minimum OBSS PD level
+    dBm_u m_obssPdLevelMax; ///< Maximum OBSS PD level
+    dBm_u m_txPowerRefSiso; ///< SISO reference TX power level
+    dBm_u m_txPowerRefMimo; ///< MIMO reference TX power level
 
     /**
      * TracedCallback signature for PHY reset events.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.42/src/wifi/model/he/rr-multi-user-scheduler.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -155,7 +144,9 @@
         return SU_TX;
     }
 
-    if (m_enableUlOfdma && m_enableBsrp && (GetLastTxFormat(m_linkId) == DL_MU_TX || !mpdu))
+    if (m_enableUlOfdma && m_enableBsrp &&
+        (GetLastTxFormat(m_linkId) == DL_MU_TX ||
+         ((m_initialFrame || m_trigger.GetType() != TriggerFrameType::BSRP_TRIGGER) && !mpdu)))
     {
         TxFormat txFormat = TrySendingBsrpTf();
 
@@ -178,9 +169,8 @@
     return TrySendingDlMuPpdu();
 }
 
-template <class Func>
 WifiTxVector
-RrMultiUserScheduler::GetTxVectorForUlMu(Func canBeSolicited)
+RrMultiUserScheduler::GetTxVectorForUlMu(std::function<bool(const MasterInfo&)> canBeSolicited)
 {
     NS_LOG_FUNCTION(this);
 
@@ -201,7 +191,7 @@
     WifiTxVector txVector;
     txVector.SetPreambleType(WIFI_PREAMBLE_HE_TB);
     txVector.SetChannelWidth(m_allowedWidth);
-    txVector.SetGuardInterval(heConfiguration->GetGuardInterval().GetNanoSeconds());
+    txVector.SetGuardInterval(heConfiguration->GetGuardInterval());
     txVector.SetBssColor(heConfiguration->GetBssColor());
 
     // iterate over the associated stations until an enough number of stations is identified
@@ -288,6 +278,59 @@
     return txVector;
 }
 
+bool
+RrMultiUserScheduler::CanSolicitStaInBsrpTf(const MasterInfo& info) const
+{
+    // check if station has setup the current link
+    if (!m_apMac->GetStaList(m_linkId).contains(info.aid))
+    {
+        NS_LOG_INFO("STA with AID " << info.aid << " has not setup link " << +m_linkId);
+        return false;
+    }
+
+    auto mldAddr = GetWifiRemoteStationManager(m_linkId)->GetMldAddress(info.address);
+
+    // remaining checks are for MLDs only
+    if (!mldAddr)
+    {
+        return true;
+    }
+
+    // check if at least one TID is mapped on the current link in the UL direction
+    bool mapped = false;
+    for (uint8_t tid = 0; tid < 8; ++tid)
+    {
+        if (m_apMac->TidMappedOnLink(*mldAddr, WifiDirection::UPLINK, tid, m_linkId))
+        {
+            mapped = true;
+            break;
+        }
+    }
+
+    if (!mapped)
+    {
+        NS_LOG_DEBUG("MLD " << *mldAddr << " has not mapped any TID on link " << +m_linkId);
+        return false;
+    }
+
+    // check if the station is an EMLSR client that is using another link
+    if (GetWifiRemoteStationManager(m_linkId)->GetEmlsrEnabled(info.address) &&
+        (m_apMac->GetTxBlockedOnLink(AC_BE,
+                                     {WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *mldAddr, 0},
+                                     m_linkId,
+                                     WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK) ||
+         m_apMac->GetTxBlockedOnLink(AC_BE,
+                                     {WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *mldAddr, 0},
+                                     m_linkId,
+                                     WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY)))
+    {
+        NS_LOG_INFO("EMLSR client " << *mldAddr << " is using another link");
+        return false;
+    }
+
+    return true;
+}
+
 MultiUserScheduler::TxFormat
 RrMultiUserScheduler::TrySendingBsrpTf()
 {
@@ -299,11 +342,8 @@
         return TxFormat::SU_TX;
     }
 
-    // only consider stations that have setup the current link
-    WifiTxVector txVector = GetTxVectorForUlMu([this](const MasterInfo& info) {
-        const auto& staList = m_apMac->GetStaList(m_linkId);
-        return staList.contains(info.aid);
-    });
+    auto txVector = GetTxVectorForUlMu(
+        std::bind(&RrMultiUserScheduler::CanSolicitStaInBsrpTf, this, std::placeholders::_1));
 
     if (txVector.GetHeMuUserInfoMap().empty())
     {
@@ -372,6 +412,19 @@
     return UL_MU_TX;
 }
 
+bool
+RrMultiUserScheduler::CanSolicitStaInBasicTf(const MasterInfo& info) const
+{
+    // in addition to the checks performed when sending a BSRP TF, also check if the station
+    // has reported a null queue size
+    if (!CanSolicitStaInBsrpTf(info))
+    {
+        return false;
+    }
+
+    return m_apMac->GetMaxBufferStatus(info.address) > 0;
+}
+
 MultiUserScheduler::TxFormat
 RrMultiUserScheduler::TrySendingBasicTf()
 {
@@ -386,12 +439,8 @@
     // check if an UL OFDMA transmission is possible after a DL OFDMA transmission
     NS_ABORT_MSG_IF(m_ulPsduSize == 0, "The UlPsduSize attribute must be set to a non-null value");
 
-    // only consider stations that have setup the current link and do not have
-    // reported a null queue size
-    WifiTxVector txVector = GetTxVectorForUlMu([this](const MasterInfo& info) {
-        const auto& staList = m_apMac->GetStaList(m_linkId);
-        return staList.contains(info.aid) && m_apMac->GetMaxBufferStatus(info.address) > 0;
-    });
+    auto txVector = GetTxVectorForUlMu(
+        std::bind(&RrMultiUserScheduler::CanSolicitStaInBasicTf, this, std::placeholders::_1));
 
     if (txVector.GetHeMuUserInfoMap().empty())
     {
@@ -651,7 +700,7 @@
     m_txParams.Clear();
     m_txParams.m_txVector.SetPreambleType(WIFI_PREAMBLE_HE_MU);
     m_txParams.m_txVector.SetChannelWidth(m_allowedWidth);
-    m_txParams.m_txVector.SetGuardInterval(heConfiguration->GetGuardInterval().GetNanoSeconds());
+    m_txParams.m_txVector.SetGuardInterval(heConfiguration->GetGuardInterval());
     m_txParams.m_txVector.SetBssColor(heConfiguration->GetBssColor());
 
     // The TXOP limit can be exceeded by the TXOP holder if it does not transmit more
@@ -665,7 +714,7 @@
     m_candidates.clear();
 
     std::vector<uint8_t> ruAllocations;
-    auto numRuAllocs = m_txParams.m_txVector.GetChannelWidth() / 20;
+    const std::size_t numRuAllocs = m_txParams.m_txVector.GetChannelWidth() / 20;
     ruAllocations.resize(numRuAllocs);
     NS_ASSERT((m_candidates.size() % numRuAllocs) == 0);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/rr-multi-user-scheduler.h ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.h
--- ns-3.42/src/wifi/model/he/rr-multi-user-scheduler.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -22,6 +11,7 @@
 
 #include "multi-user-scheduler.h"
 
+#include <functional>
 #include <list>
 
 namespace ns3
@@ -56,6 +46,32 @@
     void DoDispose() override;
     void DoInitialize() override;
 
+    /**
+     * Information used to sort stations
+     */
+    struct MasterInfo
+    {
+        uint16_t aid;         //!< station's AID
+        Mac48Address address; //!< station's MAC Address
+        double credits;       //!< credits accumulated by the station
+    };
+
+    /**
+     * Determine whether the given STA can be solicited via a Basic Trigger Frame.
+     *
+     * \param info the information about the given STA
+     * \return whether the given STA can be solicited via a Basic Trigger Frame
+     */
+    virtual bool CanSolicitStaInBasicTf(const MasterInfo& info) const;
+
+    /**
+     * Determine whether the given STA can be solicited via a BSRP Trigger Frame.
+     *
+     * \param info the information about the given STA
+     * \return whether the given STA can be solicited via a BSRP Trigger Frame
+     */
+    virtual bool CanSolicitStaInBsrpTf(const MasterInfo& info) const;
+
   private:
     TxFormat SelectTxFormat() override;
     DlMuInfo ComputeDlMuInfo() override;
@@ -93,13 +109,11 @@
      * transmissions from suitable stations, i.e., stations that have established a
      * BlockAck agreement with the AP and for which the given predicate returns true.
      *
-     * \tparam Func \deduced the type of the given predicate
      * \param canBeSolicited a predicate returning false for stations that shall not be solicited
      * \return a TXVECTOR that can be used to construct a Trigger Frame to solicit
      *         transmissions from suitable stations
      */
-    template <class Func>
-    WifiTxVector GetTxVectorForUlMu(Func canBeSolicited);
+    virtual WifiTxVector GetTxVectorForUlMu(std::function<bool(const MasterInfo&)> canBeSolicited);
 
     /**
      * Notify the scheduler that a station associated with the AP
@@ -117,16 +131,6 @@
     void NotifyStationDeassociated(uint16_t aid, Mac48Address address);
 
     /**
-     * Information used to sort stations
-     */
-    struct MasterInfo
-    {
-        uint16_t aid;         //!< station's AID
-        Mac48Address address; //!< station's MAC Address
-        double credits;       //!< credits accumulated by the station
-    };
-
-    /**
      * Finalize the given TXVECTOR by only including the largest subset of the
      * current set of candidate stations that can be allocated equal-sized RUs
      * (with the possible exception of using central 26-tone RUs) without
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-capabilities.cc ns-3.43/src/wifi/model/ht/ht-capabilities.cc
--- ns-3.42/src/wifi/model/ht/ht-capabilities.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/ht/ht-capabilities.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Ghada Badawy <gbadawy@rim.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-capabilities.h ns-3.43/src/wifi/model/ht/ht-capabilities.h
--- ns-3.42/src/wifi/model/ht/ht-capabilities.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/ht/ht-capabilities.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Ghada Badawy <gbadawy@gmail.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-configuration.cc ns-3.43/src/wifi/model/ht/ht-configuration.cc
--- ns-3.42/src/wifi/model/ht/ht-configuration.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/ht/ht-configuration.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018  Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-configuration.h ns-3.43/src/wifi/model/ht/ht-configuration.h
--- ns-3.42/src/wifi/model/ht/ht-configuration.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/ht/ht-configuration.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018  Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.42/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -220,7 +209,7 @@
 }
 
 void
-HtFrameExchangeManager::SendAddBaResponse(const MgtAddBaRequestHeader* reqHdr,
+HtFrameExchangeManager::SendAddBaResponse(const MgtAddBaRequestHeader& reqHdr,
                                           Mac48Address originator)
 {
     NS_LOG_FUNCTION(this << originator);
@@ -237,9 +226,9 @@
     code.SetSuccess();
     respHdr.SetStatusCode(code);
     // Here a control about queues type?
-    respHdr.SetAmsduSupport(reqHdr->IsAmsduSupported());
+    respHdr.SetAmsduSupport(reqHdr.IsAmsduSupported());
 
-    if (reqHdr->IsImmediateBlockAck())
+    if (reqHdr.IsImmediateBlockAck())
     {
         respHdr.SetImmediateBlockAck();
     }
@@ -247,12 +236,12 @@
     {
         respHdr.SetDelayedBlockAck();
     }
-    auto tid = reqHdr->GetTid();
+    auto tid = reqHdr.GetTid();
     respHdr.SetTid(tid);
 
     auto bufferSize = std::min(m_mac->GetMpduBufferSize(), m_mac->GetMaxBaBufferSize(originator));
     respHdr.SetBufferSize(bufferSize);
-    respHdr.SetTimeout(reqHdr->GetTimeout());
+    respHdr.SetTimeout(reqHdr.GetTimeout());
 
     WifiActionHeader actionHdr;
     WifiActionHeader::ActionValue action;
@@ -270,7 +259,7 @@
     }
     GetBaManager(tid)->CreateRecipientAgreement(respHdr,
                                                 originator,
-                                                reqHdr->GetStartingSequence(),
+                                                reqHdr.GetStartingSequence(),
                                                 m_rxMiddle);
 
     auto agreement = GetBaManager(tid)->GetAgreementAsRecipient(originator, tid);
@@ -810,7 +799,13 @@
             }
         }
     }
-    QosFrameExchangeManager::NotifyPacketDiscarded(mpdu);
+    // the MPDU may have been dropped (and dequeued) by the above call to the NotifyDiscardedMpdu
+    // method of the BlockAckManager with reason WIFI_MAC_DROP_QOS_OLD_PACKET; in such a case, we
+    // must not fire the dropped callback again (with reason WIFI_MAC_DROP_REACHED_RETRY_LIMIT)
+    if (mpdu->IsQueued())
+    {
+        QosFrameExchangeManager::NotifyPacketDiscarded(mpdu);
+    }
 }
 
 void
@@ -1101,7 +1096,8 @@
                 // set the Queue Size subfield of the QoS Control field
                 if (!queueSizeForTid[tid].has_value())
                 {
-                    queueSizeForTid[tid] = edca->GetQosQueueSize(tid, hdr.GetAddr1());
+                    queueSizeForTid[tid] =
+                        edca->GetQosQueueSize(tid, mpdu->GetOriginal()->GetHeader().GetAddr1());
                 }
 
                 hdr.SetQosEosp();
@@ -1662,10 +1658,105 @@
         // to a Block Ack agreement
     }
 
+    if (hdr.IsMgt() && hdr.IsAction())
+    {
+        ReceiveMgtAction(mpdu, txVector);
+    }
+
     QosFrameExchangeManager::ReceiveMpdu(mpdu, rxSignalInfo, txVector, inAmpdu);
 }
 
 void
+HtFrameExchangeManager::ReceiveMgtAction(Ptr<const WifiMpdu> mpdu, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << *mpdu << txVector);
+
+    NS_ASSERT(mpdu->GetHeader().IsAction());
+    const auto from = mpdu->GetOriginal()->GetHeader().GetAddr2();
+
+    WifiActionHeader actionHdr;
+    auto packet = mpdu->GetPacket()->Copy();
+    packet->RemoveHeader(actionHdr);
+
+    // compute the time to transmit the Ack
+    const auto ackTxVector =
+        GetWifiRemoteStationManager()->GetAckTxVector(mpdu->GetHeader().GetAddr2(), txVector);
+    const auto ackTxTime =
+        WifiPhy::CalculateTxDuration(GetAckSize(), ackTxVector, m_phy->GetPhyBand());
+
+    switch (actionHdr.GetCategory())
+    {
+    case WifiActionHeader::BLOCK_ACK:
+
+        switch (actionHdr.GetAction().blockAck)
+        {
+        case WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST: {
+            MgtAddBaRequestHeader reqHdr;
+            packet->RemoveHeader(reqHdr);
+
+            // We've received an ADDBA Request. Our policy here is to automatically accept it,
+            // so we get the ADDBA Response on its way as soon as we finish transmitting the Ack,
+            // to avoid to concurrently send Ack and ADDBA Response in case of multi-link devices
+            Simulator::Schedule(m_phy->GetSifs() + ackTxTime,
+                                &HtFrameExchangeManager::SendAddBaResponse,
+                                this,
+                                reqHdr,
+                                from);
+            // This frame is now completely dealt with, so we're done.
+            return;
+        }
+        case WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE: {
+            MgtAddBaResponseHeader respHdr;
+            packet->RemoveHeader(respHdr);
+
+            // We've received an ADDBA Response. Wait until we finish transmitting the Ack before
+            // unblocking transmissions to the recipient, otherwise for multi-link devices the Ack
+            // may be sent concurrently with a data frame containing an A-MPDU
+            Simulator::Schedule(m_phy->GetSifs() + ackTxTime, [=, this]() {
+                const auto recipient =
+                    GetWifiRemoteStationManager()->GetMldAddress(from).value_or(from);
+                m_mac->GetQosTxop(respHdr.GetTid())->GotAddBaResponse(respHdr, recipient);
+                GetBaManager(respHdr.GetTid())
+                    ->SetBlockAckInactivityCallback(
+                        MakeCallback(&HtFrameExchangeManager::SendDelbaFrame, this));
+            });
+            // This frame is now completely dealt with, so we're done.
+            return;
+        }
+        case WifiActionHeader::BLOCK_ACK_DELBA: {
+            MgtDelBaHeader delBaHdr;
+            packet->RemoveHeader(delBaHdr);
+            auto recipient = GetWifiRemoteStationManager()->GetMldAddress(from).value_or(from);
+
+            if (delBaHdr.IsByOriginator())
+            {
+                // This DELBA frame was sent by the originator, so
+                // this means that an ingoing established
+                // agreement exists in BlockAckManager and we need to
+                // destroy it.
+                GetBaManager(delBaHdr.GetTid())
+                    ->DestroyRecipientAgreement(recipient, delBaHdr.GetTid());
+            }
+            else
+            {
+                // We must have been the originator. We need to
+                // tell the correct queue that the agreement has
+                // been torn down
+                m_mac->GetQosTxop(delBaHdr.GetTid())->GotDelBaFrame(&delBaHdr, recipient);
+            }
+            // This frame is now completely dealt with, so we're done.
+            return;
+        }
+        default:
+            NS_FATAL_ERROR("Unsupported Action field in Block Ack Action frame");
+        }
+    default:
+        // Other action frames are not processed here
+        ;
+    }
+}
+
+void
 HtFrameExchangeManager::EndReceiveAmpdu(Ptr<const WifiPsdu> psdu,
                                         const RxSignalInfo& rxSignalInfo,
                                         const WifiTxVector& txVector,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-frame-exchange-manager.h ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.h
--- ns-3.42/src/wifi/model/ht/ht-frame-exchange-manager.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -138,10 +127,10 @@
      * This method can be called to accept a received ADDBA Request. An
      * ADDBA Response will be constructed and queued for transmission.
      *
-     * \param reqHdr a pointer to the received ADDBA Request header.
+     * \param reqHdr the received ADDBA Request header.
      * \param originator the MAC address of the originator.
      */
-    void SendAddBaResponse(const MgtAddBaRequestHeader* reqHdr, Mac48Address originator);
+    void SendAddBaResponse(const MgtAddBaRequestHeader& reqHdr, Mac48Address originator);
 
     /**
      * Sends DELBA frame to cancel a block ack agreement with STA
@@ -190,6 +179,14 @@
     void ProtectionCompleted() override;
 
     /**
+     * Process a received management action frame that relates to Block Ack agreement.
+     *
+     * \param mpdu the MPDU carrying the received management action frame
+     * \param txVector the TXVECTOR used to transmit the management action frame
+     */
+    void ReceiveMgtAction(Ptr<const WifiMpdu> mpdu, const WifiTxVector& txVector);
+
+    /**
      * Get a PSDU containing the given MPDU
      *
      * \param mpdu the given MPDU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-operation.cc ns-3.43/src/wifi/model/ht/ht-operation.cc
--- ns-3.42/src/wifi/model/ht/ht-operation.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-operation.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-operation.h ns-3.43/src/wifi/model/ht/ht-operation.h
--- ns-3.42/src/wifi/model/ht/ht-operation.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-operation.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -318,7 +307,7 @@
      * Return MCS is supported.
      *
      * \param mcs MCS
-     *\
+     *
      * \return the MCS is supported
      */
     bool IsSupportedMcs(uint8_t mcs) const;
